diff -r -u -H -N gcc-2.6.3/sched.c gcc-i2.6.3/sched.c
--- gcc-2.6.3/sched.c	Tue Sep 20 15:55:14 1994
+++ gcc-i2.6.3/sched.c	Wed Feb 15 23:52:38 1995
@@ -4941,4 +5621,286 @@
 	  }
     }
 }
+/* intel1
+   return 1 if insn_b is part of the SCHED_GROUP of insn_a 
+*/
+static int
+is_part_of_group (insn_a, insn_b)
+     rtx insn_a;
+     rtx insn_b;
+{
+  rtx pn;
+
+  pn = PREV_INSN(insn_a);
+  while(pn)
+    {
+      if(GET_CODE(pn)==INSN || GET_CODE(pn)==CALL_INSN ||
+         GET_CODE(pn)==JUMP_INSN)
+        {
+          if(pn==insn_b)
+            {
+              return(1);
+            }
+          if(!SCHED_GROUP_P(pn))
+            {
+              return(0);
+            }
+        }
+      pn = PREV_INSN(pn);
+    }
+  return(0);
+}
+
+/* intel1 return 1 if there are insts in block b before insn */
+static int prev_insts_in_block(b, insn)
+int b;
+rtx insn;
+{
+  insn = PREV_INSN(insn);
+  while(insn && insn!=basic_block_head[b])
+    {
+      if(GET_RTX_CLASS (GET_CODE (insn)) == 'i')
+        {
+          return(1);
+        }
+      insn = PREV_INSN(insn);
+    }
+  if(insn && 
+     insn==basic_block_head[b] && GET_RTX_CLASS (GET_CODE (insn)) == 'i')
+    {
+      return(1);
+    }
+  return(0);
+}
+
+#ifdef AGI
+/* intel1
+  If insn updates a register by a constant and NEXT_INSN (insn) uses
+  that register as a base or index and this is the only dependence
+  between the two insns - then try to swap these two insns by replacing
+  register with (register + constant) in NEXT_INSN (insn).  
+*/
+int try_eliminate_agi (insn, file)
+  rtx insn;
+  FILE * file;
+{
+  rtx next;
+  int success;
+  
+  next = NEXT_INSN (insn);
+  if (!try_swap (insn))
+    {
+      return (0);
+    }
+  /* Now swap insn with next.  */
+  PREV_INSN (NEXT_INSN (next)) = insn;
+  NEXT_INSN (insn) = NEXT_INSN (next);
+  NEXT_INSN (next) = insn;
+  PREV_INSN (insn) = next;
+  success = 1;
+  if (file)
+    {
+      fprintf (file, ";; swapped %d with %d to eliminate agi, %d is last scheduled\n",
+      INSN_UID (insn), INSN_UID (next), INSN_UID (next));
+    }
+  while (success)
+    {  /* Keep trying to swap insn downwards */
+      success = try_swap (insn);
+      if (success)
+        {
+          next = NEXT_INSN (insn);
+          if (file)
+            {
+              fprintf (file, ";;   (swapped %d with %d to eliminate agi)\n",
+              INSN_UID (insn), INSN_UID (next));
+            }
+          NEXT_INSN (PREV_INSN (insn)) = next;
+          PREV_INSN (next) = PREV_INSN (insn);
+          PREV_INSN (NEXT_INSN (next)) = insn;
+          NEXT_INSN (insn) = NEXT_INSN (next);
+          NEXT_INSN (next) = insn;
+          PREV_INSN (insn) = next;
+        }
+    }
+  return (1);
+}
+
+int try_swap (insn)
+  rtx insn;
+{
+  rtx next, tmp, src, dest, next_src, next_dest, reg_to_update,
+      copy_dest, copy_src;
+  int offst_update, updates_by_const, regno_updated, length, i,
+      insn_code_number, save_code;
+  char * fmt, * storage;
+  next = NEXT_INSN (insn);
+  if (GET_CODE (insn) != INSN || next == NULL || GET_CODE (next) != INSN
+      || GET_CODE (PATTERN (insn)) != SET || GET_CODE (PATTERN (next)) != SET)
+    {
+      return (0);
+    }
+  src = SET_SRC (PATTERN (insn));
+  dest = SET_DEST (PATTERN (insn));
+  next_src = SET_SRC (PATTERN (next));
+  next_dest = SET_DEST (PATTERN (next));
+  if (next_dest == cc0_rtx)
+    {
+      return (0);
+    }
+  if (rtx_equal_p (dest, next_dest))
+    {
+      return (0);
+    }
+  if (GET_CODE (next_dest) == REG)
+    {
+      if (reg_overlap_mentioned_p (next_dest, PATTERN (insn)))
+        {
+          return (0);
+        }
+    }
+  /* See if insn updates some register by a constant ammount */
+  updates_by_const = 0;
+  if (GET_CODE (dest) == REG)
+    {
+      if ((GET_CODE (src) == PLUS || GET_CODE (src) == MINUS)
+          && rtx_equal_p (XEXP (src, 0), dest) 
+          && GET_CODE (XEXP (src, 1)) == CONST_INT)
+        {
+          updates_by_const = 1;
+          offst_update 
+            = XINT (XEXP (src, 1), 0) * (GET_CODE (src) == PLUS ? 1 : -1);
+          regno_updated = REGNO (dest);
+          reg_to_update = dest;
+        }
+    }
+  if (GET_CODE (dest) == MEM && push_operand (dest, GET_MODE (dest))
+      && (GET_CODE (src) == REG
+          || (GET_CODE (src) == MEM && !side_effects_p (XEXP (src, 0)))))
+    {
+      updates_by_const = 1;
+      offst_update = GET_MODE_SIZE (GET_MODE (dest));
+      if (GET_CODE (XEXP (dest, 0)) == PRE_DEC ||
+          GET_CODE (XEXP (dest, 0)) == POST_DEC)
+        {
+          offst_update *= -1;
+        }
+      regno_updated = STACK_POINTER_REGNUM;
+      reg_to_update = stack_pointer_rtx;
+    }
+  if (!updates_by_const)
+    {
+      return (0);
+    }
+  if (!reg_overlap_mentioned_p (reg_to_update, PATTERN (next)))
+    {
+      return (0);
+    }
+  if (GET_CODE (dest) == MEM)
+    {
+      if (GET_CODE (next_src) == MEM
+           && true_dependence (dest, next_src))
+        {
+          return (0);
+        }
+      else if (GET_CODE (next_src) != REG)
+        {
+          fmt = GET_RTX_FORMAT (GET_CODE (next_src));
+          length = GET_RTX_LENGTH (GET_CODE (next_src));
+          for (i=0; i<length; i++)
+            {
+              if (fmt[i] == 'e' && GET_CODE (XEXP (next_src, i)) == MEM)
+                {
+                  if (true_dependence (dest, XEXP (next_src, i)))
+                    {
+                      return (0);
+                    }
+                }
+            }
+        }
+      if (GET_CODE (next_dest) == MEM
+           && true_dependence (dest, next_dest))
+        {
+          return (0);
+        }
+    }
+  if (GET_CODE (src) == MEM)
+    {
+      if (GET_CODE (next_dest) == MEM
+           && true_dependence (src, next_dest))
+        {
+          return (0);
+        }
+    }
+  /* First check that regno_updated is not used in next with any
+     other mode */
+  init_undo_buf ();
+  subst_in_insn (next, PATTERN (next), reg_to_update, const0_rtx, 0, 0);
+  if (reg_overlap_mentioned_p (reg_to_update, PATTERN (next)))
+    {
+      loop_undo_all ();
+      return (0);
+    }
+  loop_undo_all ();
+  /* Now substitute reg_to_update with  reg_to_update + offst_update.  */
+  storage = (char *) oballoc (0);
+  /* Since may be sharing of rtl */
+  copy_dest = copy_rtx (next_dest);
+  copy_src = copy_rtx (next_src);
+  SET_SRC (PATTERN (next)) = copy_src;
+  SET_DEST (PATTERN (next)) = copy_dest;
+  init_undo_buf ();
+  subst_in_insn (next, PATTERN (next), reg_to_update,
+                 gen_rtx (PLUS , GET_MODE (reg_to_update), reg_to_update,
+                          gen_rtx (CONST_INT, 0, offst_update)), 0, 0);
+#ifdef REWRITE_ADDRESS
+  if (GET_CODE (copy_dest) == MEM)
+    {
+      REWRITE_ADDRESS (copy_dest);
+    }
+  if (GET_CODE (copy_src) == MEM)
+    {
+      REWRITE_ADDRESS (copy_src);
+    }
+  else
+    {
+      fmt = GET_RTX_FORMAT (GET_CODE (copy_src));
+      length = GET_RTX_LENGTH (GET_CODE (copy_src));
+      for (i=0; i<length; i++)
+        {
+          if (fmt[i] == 'e' && GET_CODE (XEXP (copy_src, i)) == MEM)
+            {
+              REWRITE_ADDRESS (XEXP (copy_src, i));
+            }
+        }
+    }
+#endif
+  if ((insn_code_number = recog (PATTERN (next), next, 0)) < 0)
+    {
+      loop_undo_all ();
+      SET_DEST (PATTERN (next)) = next_dest;
+      SET_SRC (PATTERN (next)) = next_src;
+      obfree (storage);
+      return (0);
+    }
+  else
+    {
+#ifdef REGISTER_CONSTRAINTS
+      save_code = INSN_CODE (next);
+      INSN_CODE (next) = insn_code_number;
+      insn_extract (next);
+      if (!constrain_operands (insn_code_number, 1))
+	{
+	  loop_undo_all ();
+          SET_DEST (PATTERN (next)) = next_dest;
+          SET_SRC (PATTERN (next)) = next_src;
+	  INSN_CODE (next) = save_code;
+          obfree (storage);
+	  return (0);
+	}
+#endif
+    }
+  return (1);
+}
+#endif
+
 #endif /* INSN_SCHEDULING */
diff -r -u -H -N gcc-2.6.3/toplev.c gcc-i2.6.3/toplev.c
--- gcc-2.6.3/toplev.c	Tue Oct 25 16:09:12 1994
+++ gcc-i2.6.3/toplev.c	Thu Feb 16 11:49:14 1995
@@ -195,7 +195,9 @@
 int combine_dump = 0;
 int sched_dump = 0;
 int local_reg_dump = 0;
+int memory_simplify_dump = 0; /* intel2 */
 int global_reg_dump = 0;
+int loop2_dump = 0; /* intel1 */
 int sched2_dump = 0;
 int jump2_opt_dump = 0;
 int dbr_sched_dump = 0;
@@ -364,6 +366,42 @@
 /* Nonzero enables strength-reduction in loop.c.  */
 
 int flag_strength_reduce = 0;
+/* intel1 my optimization controllers */
+int flag_opt_reg_use = 0;
+int flag_all_mem_givs = 0;
+int flag_reduce_index_givs = 0;
+int flag_peep_spills = 0;
+int flag_loop_after_global = 0;
+int flag_jump_back = 0;
+int flag_copy_prop = 0;
+int flag_lift_stores = 0;
+int flag_runtime_lift_stores = 0;
+int flag_compare_elim = 0;
+int flag_sign_extension_elim = 0;
+int flag_sftwr_pipe = 0;
+int flag_opt_jumps_out = 0;
+int flag_replace_mem = 0;
+int flag_replace_stack_mem = 0;
+int flag_reg_reg_copy_opt = 0;
+int flag_do_offload = 0;
+int flag_opt_reg_stack = 0;
+int flag_correct_cse_mistakes = 0;
+int flag_push_load_into_loop = 0;
+int flag_risc = 0;
+int flag_risc_const = 0;
+int flag_risc_mem_dest = 0;	/* intel2 */
+int flag_replace_reload_regs = 0;
+int flag_recombine = 0;
+int flag_swap_for_agi = 0;
+int flag_no_omit_frame_pointer = 0;
+int flag_no_risc = 0;
+int flag_no_risc_const = 0;
+int flag_no_risc_mem_dest = 0;	/* intel2 */
+int flag_no_recombine = 0;
+int flag_schedule_stack_reg_insns = 0;
+int flag_interleave_stack_non_stack = 0;
+int flag_no_schedule_stack_reg_insns = 0;
+int flag_no_interleave_stack_non_stack = 0;
 
 /* Nonzero enables loop unrolling in unroll.c.  Only loops for which the
    number of iterations can be calculated at compile-time (UNROLL_COMPLETELY,
@@ -553,7 +591,42 @@
   {"inhibit-size-directive", &flag_inhibit_size_directive, 1},
   {"verbose-asm", &flag_verbose_asm, 1},
   {"gnu-linker", &flag_gnu_linker, 1},
-  {"bytecode", &output_bytecode, 1}
+  {"bytecode", &output_bytecode, 1},
+  /* intel1 */
+  {"compare-elim", &flag_compare_elim, 1},
+  {"sign-extension-elim", &flag_sign_extension_elim, 1},
+  {"jump-back", &flag_jump_back, 1},
+  {"loop-after-global", &flag_loop_after_global, 1},
+  {"opt-reg-use", &flag_opt_reg_use, 1},
+  {"all-mem-givs", &flag_all_mem_givs, 1},
+  {"reduce-index-givs", &flag_reduce_index_givs, 1},
+  {"peep-spills", &flag_peep_spills, 1},
+  {"copy-prop", &flag_copy_prop, 1},
+  {"lift-stores", &flag_lift_stores, 1},
+  {"runtime-lift-stores", &flag_runtime_lift_stores, 1},
+  {"do-offload", &flag_do_offload, 1},
+  {"opt-reg-stack", &flag_opt_reg_stack, 1},
+  {"correct-cse-mistakes", &flag_correct_cse_mistakes, 1},
+  {"spl", &flag_sftwr_pipe, 1},
+  {"opt-jumps-out", &flag_opt_jumps_out, 1},
+  {"replace-mem", &flag_replace_mem, 1},
+  {"replace-stack-mem", &flag_replace_stack_mem, 1},
+  {"no-interleave-stack-non-stack", &flag_no_interleave_stack_non_stack, 1},
+  {"interleave-stack-non-stack", &flag_interleave_stack_non_stack, 1},
+  {"no-schedule-stack-reg-insns", &flag_no_schedule_stack_reg_insns, 1},
+  {"schedule-stack-reg-insns", &flag_schedule_stack_reg_insns, 1},
+  {"reg-reg-copy-opt", &flag_reg_reg_copy_opt, 1},
+  {"push-load-into-loop", &flag_push_load_into_loop, 1},
+  {"swap-for-agi", &flag_swap_for_agi, 1},
+  {"no-recombine", &flag_no_recombine, 1},
+  {"recombine", &flag_recombine, 1},
+  {"no-risc", &flag_no_risc, 1},
+  {"risc", &flag_risc, 1},
+  {"no-risc-const", &flag_no_risc_const, 1},
+  {"risc-const", &flag_risc_const, 1},
+  {"replace-reload-regs", &flag_replace_reload_regs, 1},
+  {"no-risc-mem-dest", &flag_no_risc_mem_dest, 1},	/* intel2 */
+  {"risc-mem-dest", &flag_risc_mem_dest, 1},	/* intel2 */
 };
 
 /* Table of language-specific options.  */
@@ -821,6 +894,9 @@
 FILE *sched_dump_file;
 FILE *local_reg_dump_file;
 FILE *global_reg_dump_file;
+FILE *memory_simplify_dump_file; /* intel2 */
+/* intel1 */
+FILE *loop2_dump_file;
 FILE *sched2_dump_file;
 FILE *jump2_opt_dump_file;
 FILE *dbr_sched_dump_file;
@@ -840,6 +916,9 @@
 int sched_time;
 int local_alloc_time;
 int global_alloc_time;
+int memory_simplify_time; /* intel2 */
+/* intel1 */
+int loop2_time;
 int sched2_time;
 int dbr_sched_time;
 int shorten_branch_time;
@@ -987,6 +1066,10 @@
     fflush (local_reg_dump_file);
   if (global_reg_dump_file)
     fflush (global_reg_dump_file);
+  if (memory_simplify_dump_file) /* intel2 */
+      fflush (memory_simplify_dump_file);
+  if (loop2_dump_file) /* intel1 */
+    fflush (loop2_dump_file);
   if (sched2_dump_file)
     fflush (sched2_dump_file);
   if (jump2_opt_dump_file)
@@ -2045,6 +2128,9 @@
   sched_time = 0;
   local_alloc_time = 0;
   global_alloc_time = 0;
+  memory_simplify_time = 0; /* intel2 */
+  /* intel1 */
+  loop2_time = 0;
   sched2_time = 0;
   dbr_sched_time = 0;
   shorten_branch_time = 0;
@@ -2141,6 +2227,17 @@
   if (global_reg_dump)
     global_reg_dump_file = open_dump_file (dump_base_name, ".greg");
 
+  /* intel1 */
+  /* If loop invariants after greg dump desired, open the output file.  */
+  if (loop2_dump)
+  	loop2_dump_file = open_dump_file(dump_base_name, ".l2" );
+
+/* intel2 - begin */
+  /* If memory_simplify dump desired, open the output file.  */
+  if (memory_simplify_dump)
+  	memory_simplify_dump_file=open_dump_file(dump_base_name, ".msim");
+/* intel2 - end */
+
   /* If 2nd scheduling dump desired, open the output file.  */
   if (sched2_dump)
     sched2_dump_file = open_dump_file (dump_base_name, ".sched2");
@@ -2549,6 +2646,12 @@
   if (global_reg_dump)
     fclose (global_reg_dump_file);
 
+  if (memory_simplify_dump)
+    fclose (memory_simplify_dump_file); /* intel2 */
+	
+  if (loop2_dump) /* intel1 */
+    fclose (loop2_dump_file);
+
   if (sched2_dump)
     fclose (sched2_dump_file);
 
@@ -2577,28 +2680,30 @@
     {
       fprintf (stderr,"\n");
       print_time ("parse", parse_time);
-
       if (!output_bytecode)
-	{
-	  print_time ("integration", integration_time);
-	  print_time ("jump", jump_time);
-	  print_time ("cse", cse_time);
-	  print_time ("loop", loop_time);
-	  print_time ("cse2", cse2_time);
-	  print_time ("flow", flow_time);
-	  print_time ("combine", combine_time);
-	  print_time ("sched", sched_time);
-	  print_time ("local-alloc", local_alloc_time);
-	  print_time ("global-alloc", global_alloc_time);
-	  print_time ("sched2", sched2_time);
-	  print_time ("dbranch", dbr_sched_time);
-	  print_time ("shorten-branch", shorten_branch_time);
-	  print_time ("stack-reg", stack_reg_time);
-	  print_time ("final", final_time);
-	  print_time ("varconst", varconst_time);
-	  print_time ("symout", symout_time);
-	  print_time ("dump", dump_time);
-	}
+	  {
+        print_time ("integration", integration_time);
+        print_time ("jump", jump_time);
+        print_time ("cse", cse_time);
+        print_time ("loop", loop_time);
+        print_time ("cse2", cse2_time);
+        print_time ("flow", flow_time);
+        print_time ("combine", combine_time);
+        print_time ("sched", sched_time);
+        print_time ("local-alloc", local_alloc_time);
+        print_time ("global-alloc", global_alloc_time);
+        print_time ("memory-simplify", memory_simplify_time); /* intel2 */
+        /* intel1 */
+        print_time ("loop2", loop2_time);
+        print_time ("sched2", sched2_time);
+        print_time ("dbranch", dbr_sched_time);
+        print_time ("shorten-branch", shorten_branch_time);
+        print_time ("stack-reg", stack_reg_time);
+        print_time ("final", final_time);
+        print_time ("varconst", varconst_time);
+        print_time ("symout", symout_time);
+        print_time ("dump", dump_time);
+      }
     }
 }
 
@@ -3030,7 +3135,7 @@
 	 and write some of the results to dump file.  */
 
       TIMEVAR (flow_time, flow_analysis (insns, max_reg_num (),
-					 flow_dump_file));
+					 flow_dump_file /* intel2: */, 1));
       if (warn_uninitialized)
 	{
 	  uninitialized_vars_warning (DECL_INITIAL (decl));
@@ -3064,6 +3169,31 @@
 	       fflush (combine_dump_file);
 	     });
 
+  /* intel1 */
+#ifdef STACK_REGS
+#ifdef IS_STACK_MODE
+  if (optimize > 0 && flag_opt_reg_stack)
+    {
+      if(stack_reg_dump)
+        {
+          TIMEVAR (dump_time,
+	           {
+		     fprintf (stack_reg_dump_file, "\n;; Function %s\n\n",
+			      IDENTIFIER_POINTER (DECL_NAME (decl)));
+	           });
+        }
+      opt_reg_stack();
+      if(stack_reg_dump)
+        {
+          TIMEVAR (dump_time,
+	           {
+		     print_rtl (stack_reg_dump_file, insns);
+		     fflush (stack_reg_dump_file);
+	           });
+        }
+    }
+#endif
+#endif
   /* Print function header into sched dump now
      because doing the sched analysis makes some of the dump.  */
 
@@ -3131,6 +3261,12 @@
 	       failure = reload (insns, 0, global_reg_dump_file);
 	   });
 
+ /* intel1 */
+  if(optimize > 0 && flag_reg_reg_copy_opt)
+    {
+	  reg_to_reg_copy_opt(insns, global_reg_dump_file);
+    }  
+
   if (global_reg_dump)
     TIMEVAR (dump_time,
 	     {
@@ -3144,6 +3280,70 @@
 
   reload_completed = 1;
 
+#ifdef STACK_REGS
+  /* intel1 */
+  if (optimize > 0 && flag_opt_reg_stack)
+    {
+      TIMEVAR (stack_reg_time, float_to_int_cmp (insns, 0));
+    }
+#endif
+
+  /* intel1 */
+  if (loop2_dump)
+    TIMEVAR (dump_time,
+	     {
+	       fprintf (loop2_dump_file, "\n;; Function %s\n\n",
+			IDENTIFIER_POINTER (DECL_NAME (decl)));
+	     });
+
+  if(optimize>0 && flag_loop_after_global) 
+  {
+      TIMEVAR (loop2_time,
+	       {
+	         /* intel2 - begin */
+	         if (flag_replace_reload_regs)
+	           replace_reload_registers (get_insns(),
+				             loop2_dump ? loop2_dump_file : 0);
+	         /* intel2 - end */
+                 loop_after_global(get_insns(),loop2_dump ? loop2_dump_file : 0); 
+	       });
+  }
+  if (optimize>0 && flag_peep_spills)
+    {
+     TIMEVAR (loop2_time,
+	      {
+	      peep_spills(get_insns(),loop2_dump ? loop2_dump_file : 0); 
+	      });
+    }
+    
+  /* Dump rtl code after loop2 opt, if we are doing that.  */
+
+  if (loop2_dump && flag_loop_after_global)
+    TIMEVAR (dump_time,
+	     {
+	       print_rtl (loop2_dump_file, insns);
+	       fflush (loop2_dump_file);
+	     });
+
+/* intel2 - begin */
+  if (optimize>0 && flag_risc)
+    {
+      if (memory_simplify_dump)
+        TIMEVAR (dump_time,
+	         fprintf (memory_simplify_dump_file, "\n;; Function %s\n\n",
+		          IDENTIFIER_POINTER (DECL_NAME (decl))));
+    
+  	    TIMEVAR (memory_simplify_time,
+	       memory_simplify (memory_simplify_dump ? memory_simplify_dump_file : 0,
+							    insns));
+      if (memory_simplify_dump)
+        TIMEVAR (dump_time,
+	         {
+	           print_rtl (memory_simplify_dump_file, insns);
+	           fflush (memory_simplify_dump_file);
+	         });
+    }
+/* intel2 - end */
   /* On some machines, the prologue and epilogue code, or parts thereof,
      can be represented as RTL.  Doing so lets us schedule insns between
      it and the rest of the code and also allows delayed branch
@@ -3175,6 +3375,13 @@
 		 });
     }
 
+  /* intel2 - begin */
+  /* Combine those riscified insns that were not used for scheduling */
+  if (flag_risc && flag_recombine)
+    combine_unscheded (get_insns (),max_reg_num ());
+  /* intel2 - end */
+
+
 #ifdef LEAF_REGISTERS
   leaf_function = 0;
   if (optimize > 0 && only_leaf_regs_used () && leaf_function_p ())
@@ -3235,6 +3442,11 @@
 	     });
 
 #ifdef STACK_REGS
+  /* intel1 */
+  if (optimize > 0 && flag_opt_reg_stack)
+    {
+      TIMEVAR (stack_reg_time, float_to_int_cmp (insns));
+    }
   TIMEVAR (stack_reg_time, reg_to_stack (insns, stack_reg_dump_file));
   if (stack_reg_dump)
     {
@@ -3246,6 +3458,13 @@
 		 fflush (stack_reg_dump_file);
 	       });
     }
+/* intel1 spl */
+#ifdef STORE_NOT_SET_CC0
+  if(flag_sftwr_pipe)
+    {
+      do_spl(insns);
+    }
+#endif
 #endif
 
   /* Now turn the rtl into assembler code.  */
@@ -3492,10 +3711,12 @@
  		    dbr_sched_dump = 1;
  		    flow_dump = 1;
  		    global_reg_dump = 1;
+		    memory_simplify_dump = 1; /* intel2 */
  		    jump_opt_dump = 1;
  		    jump2_opt_dump = 1;
  		    local_reg_dump = 1;
  		    loop_dump = 1;
+ 		    loop2_dump = 1; /* intel1 */
  		    rtl_dump = 1;
  		    cse_dump = 1, cse2_dump = 1;
  		    sched_dump = 1;
@@ -3517,6 +3738,11 @@
 		  case 'g':
 		    global_reg_dump = 1;
 		    break;
+		  /* intel2 - begin */
+		  case 'b':
+		    memory_simplify_dump = 1;
+		    break;
+		  /* intel2 - end */
 		  case 'j':
 		    jump_opt_dump = 1;
 		    break;
@@ -3529,6 +3755,10 @@
 		  case 'L':
 		    loop_dump = 1;
 		    break;
+		    /* intel1 */
+		  case 'A':
+		    loop2_dump = 1;
+		    break;
 		  case 'm':
 		    flag_print_mem = 1;
 		    break;
@@ -3932,6 +4162,9 @@
       fprintf (stderr, "%s version %s", language_string, version_string);
 #ifdef TARGET_VERSION
       TARGET_VERSION;
+#endif
+#ifdef SUB_TARGET_VERSION
+      SUB_TARGET_VERSION;
 #endif
 #ifdef __GNUC__
 #ifndef __VERSION__
diff -r -u -H -N gcc-2.6.3/unroll.c gcc-i2.6.3/unroll.c
--- gcc-2.6.3/unroll.c	Thu Oct 20 16:28:42 1994
+++ gcc-i2.6.3/unroll.c	Wed Feb 15 22:47:30 1995
@@ -155,6 +155,9 @@
 #include <stdio.h>
 #include "loop.h"
 
+/* intel1 */
+extern FILE *loop_dump_stream;
+
 /* This controls which loops are unrolled, and by how much we unroll
    them.  */
 
@@ -1688,6 +1691,42 @@
 	  else
 	    {
 	      pattern = copy_rtx_and_substitute (pattern, map);
+/* intel1 since a DEST_ADDR giv may be only a part of an address
+   then just substituting reg+const for reg may result in an
+   invalid insn - we check for that and try to make it good */
+#if REDUCE_INDEX || SAVE_ON_REGS
+              if(GET_CODE(PATTERN(insn))==SET)
+	        {
+	          int dummy;
+	          rtx try_to_make_good(); /* see loop.c */
+	          if(recog(pattern,insn,&dummy)==-1)
+	            {
+	              try_to_make_good(SET_SRC(pattern));
+	              try_to_make_good(SET_DEST(pattern));
+  	              if(recog(pattern,insn,&dummy)==-1)
+  	              {
+  	                fprintf(stderr,"bad pattern in insn not better:\n");
+  	                debug_rtx(insn);
+  	                abort();
+  	              }
+	            }
+	        }
+#endif
+	      /* intel1 Don't want to be reusing STACK_MODE registers
+	         since that inhibits scheduling opportunities */
+#ifdef STACK_REGS
+#ifdef IS_STACK_MODE
+#ifdef ONLY_STACK_REG_REORDER
+            if (GET_CODE (pattern) == SET && GET_CODE (SET_DEST (pattern)) == REG
+                && IS_STACK_MODE (GET_MODE (SET_DEST (pattern))))
+              {
+	        tem = gen_reg_rtx (GET_MODE (SET_DEST (pattern)));
+	        map->reg_map[REGNO (SET_DEST (PATTERN (insn)))] = tem;
+	        SET_DEST (pattern) = tem;
+              }
+#endif
+#endif
+#endif
 	      copy = emit_insn (pattern);
 	    }
 	  REG_NOTES (copy) = initial_reg_note_copy (REG_NOTES (insn), map);
diff -r -u -H -N gcc-2.6.3/varasm.c gcc-i2.6.3/varasm.c
--- gcc-2.6.3/varasm.c	Mon Nov 21 22:22:11 1994
+++ gcc-i2.6.3/varasm.c	Wed Feb 15 22:47:31 1995
@@ -75,13 +75,13 @@
 
 /* Number for making the label on the next
    constant that is stored in memory.  */
-
-int const_labelno;
+/* intel1 */
+static int const_labelno = 0;
 
 /* Number for making the label on the next
    static variable internal to a function.  */
-
-int var_labelno;
+/* intel1 */
+static int var_labelno = 0;
 
 /* Carry information from ASM_DECLARE_OBJECT_NAME
    to ASM_FINISH_DECLARE_OBJECT.  */
@@ -1083,12 +1083,23 @@
 	    else
 	      {
 #ifdef ASM_OUTPUT_ALIGNED_COMMON
-		ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size,
-					   DECL_ALIGN (decl));
+/* intel1 */
+#ifdef ALIGN_DFmode
+              if (DECL_MODE (decl) == DFmode
+                  && DECL_ALIGN (decl) 
+                    == (GET_MODE_SIZE (SFmode) * BITS_PER_UNIT))
+                {
+	      ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size, 
+	      GET_MODE_SIZE (DFmode) * BITS_PER_UNIT);
+                }
+              else
+#endif
+	      ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size,
+	 	 		         DECL_ALIGN (decl));
 #else
-		ASM_OUTPUT_COMMON (asm_out_file, name, size, rounded);
+	      ASM_OUTPUT_COMMON (asm_out_file, name, size, rounded);
 #endif
-	      }
+		}
 	}
       else
 	{
@@ -1104,12 +1115,23 @@
 	    else
 	      {
 #ifdef ASM_OUTPUT_ALIGNED_LOCAL
-		ASM_OUTPUT_ALIGNED_LOCAL (asm_out_file, name, size,
-					  DECL_ALIGN (decl));
+/* intel1 */
+#ifdef ALIGN_DFmode
+            if (DECL_MODE (decl) == DFmode
+                && DECL_ALIGN (decl) 
+                  == (GET_MODE_SIZE (SFmode) * BITS_PER_UNIT))
+              {
+	    ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size, 
+	    GET_MODE_SIZE (DFmode) * BITS_PER_UNIT);
+              }
+            else
+#endif
+	    ASM_OUTPUT_ALIGNED_LOCAL (asm_out_file, name, size,
+				      DECL_ALIGN (decl));
 #else
-		ASM_OUTPUT_LOCAL (asm_out_file, name, size, rounded);
+	    ASM_OUTPUT_LOCAL (asm_out_file, name, size, rounded);
 #endif
-	      }
+		}
 	}
       goto finish;
     }
@@ -1251,6 +1273,14 @@
      from it in get_pointer_alignment.  */
   DECL_ALIGN (decl) = align;
 
+/* intel1 */
+#ifdef ALIGN_DFmode
+    if (DECL_MODE (decl) == DFmode
+        && DECL_ALIGN (decl) == (GET_MODE_SIZE (SFmode) * BITS_PER_UNIT))
+      {
+        align = GET_MODE_SIZE (DFmode) * BITS_PER_UNIT;
+      }
+#endif
   if (align > BITS_PER_UNIT)
     {
       if (output_bytecode)
@@ -3068,6 +3098,10 @@
       align = (mode == VOIDmode) ? UNITS_PER_WORD : GET_MODE_SIZE (mode);
       if (align > BIGGEST_ALIGNMENT / BITS_PER_UNIT)
 	align = BIGGEST_ALIGNMENT / BITS_PER_UNIT;
+      /* intel1 */
+#ifdef ALIGN_DFmode
+      align = (mode == DFmode) ? GET_MODE_SIZE (mode) : align;
+#endif
 
       pool_offset += align - 1;
       pool_offset &= ~ (align - 1);
diff -r -u -H -N gcc-2.6.3/version.c gcc-i2.6.3/version.c
--- gcc-2.6.3/version.c	Mon Nov 14 18:12:47 1994
+++ gcc-i2.6.3/version.c	Wed Feb 15 23:55:26 1995
@@ -1 +1 @@
-char *version_string = "2.6.3";
+char *version_string = "i2.6.3";
